/*******************************************************************************

NAME            rmem.h
VERSION         %version:  2 %
UPDATE DATE     %date_modified: Mon Jul 25 12:00:00 2016 %
PROGRAMMER      %created_by:    pdel %

        Copyright 2015-2016 NetApp, Inc. All Rights Reserved.

DESCRIPTION: Provides ioctl command and structures to access the rmem-mgr device
             properties

*******************************************************************************/


#ifndef __INCrmem
#define __INCrmem

/***  INCLUDES  ***/

#include <linux/ioctl.h>

/***  MACRO DEFINITIONS  ***/

#define RMEM_GET_INFO        _IOR('R', 0, struct device_info)
#define RMEM_CREATE_DEVS     _IOW('R', 1, struct rmem_devices)
#define RMEM_CLEAR_LENGTH    _IO ('R', 2)
#define RMEM_GET_LENGTH      _IOR('R', 3, unsigned long)

#define RMEM_SET_USEOFFSET   _IOW('R', 4, int)
#define RMEM_CLEAR_BUFFER    _IO ('R', 5)
#define RMEM_GET_FREECNT     _IOR('R', 6, int)
#define RMEM_SET_WRTOFFSET   _IOW('R', 7, int)
#define RMEM_SET_RDOFFSET    _IOW('R', 8, int)
#define RMEM_GET_WRTOFFSET   _IOR('R', 9, int)
#define RMEM_GET_RDOFFSET    _IOR('R', 10, int)

/***  TYPE DEFINITIONS  ***/
#define RMEM_NAME "rmem"
#define RMEM_DEV              "/dev/" RMEM_NAME

#define RMEM_DEVNAME_LEN      20
#define RMEM_MAX_NUM_DEVICES  6

/* Used in ECC error handling to report rpa versus heap memory */
#define RMEM_RPA_REGION_START "eos-rpa-predefined"

struct map_info
{
    unsigned long length;
    unsigned long addr;
};

struct device_info
{
    char name[RMEM_DEVNAME_LEN];
    unsigned long addr;
    unsigned long length;
    int is_core_dumped;
    int allow_file_operations;
    int clear_on_init;
};

struct rmem_devices
{
    int num_devices;
    struct device_info devices[RMEM_MAX_NUM_DEVICES];
};

/***  GLOBALS  ***/


#endif        /* End of __INCrmem */
