/*******************************************************************************

  ecc.h
  Copyright 2019 NetApp, Inc. All Rights Reserved.

  Provides definitions needed to access ECC functions by ecc_ops.c.

*******************************************************************************/

#ifndef __INCecc
#define __INCecc


/***  INCLUDES  ***/
#include <linux/kernel.h>
#include <linux/printk.h>
#include <linux/types.h>


/* Bitmap defines for return values */
#define ECC_UNCOR   0x00000001
#define ECC_COR     0x00000002
#define ECC_IN_RPA  0x00000004
#define MCE_UNCOR   0x00000008
#define MCE_COR     0x00000010
#define MCE_UNKNOWN 0x00000020

/***  MACRO DEFINITIONS  ***/

#define mce_printk(v, s, a...) do {       \
        if (!(mce_in_progress))           \
            printk(v s, ##a);             \
        } while (0)


/***  EXTERN DEFINITIONS  ***/
extern bool mce_in_progress;


/*** FUNCTION PROTOTYPES ***/
extern bool     enable_patrol_scrub(bool enable);
extern void     ecc_inject(uint64_t madddr, uint8_t bit, uint8_t immediate);
extern void     mce_enable_mb(bool enable);
extern bool     mce_mb_enabled(void);
extern uint32_t check_for_errors(bool enable_log);
extern int32_t  maddr_to_dimm(uint64_t addr);
extern int      ecc_init(void);

#endif        /* End of __INCecc */
