/*******************************************************************************

  eccP.h
  Copyright 2019 NetApp, Inc. All Rights Reserved.

  Provides private definitions needed by derived ECC interfaces

*******************************************************************************/

#ifndef __INCeccP
#define __INCeccP


/***  INCLUDES  ***/
#include <linux/types.h>

#include "eki_common.h"

/***  STRUCTURES ***/
typedef struct
{
    bool     (*enable_patrol_scrub)(bool enable);
    void     (*ecc_inject)(uint64_t maddr, uint8_t bit, uint8_t immediate);
    bool     (*mce_mb_enabled)(void);
    void     (*mce_enable_mb)(bool enable);
    uint32_t (*check_for_errors)(bool log_enable);
    int32_t  (*maddr_to_dimm)(uint64_t addr);
    void     (*init)(void);
} ECC_INTERFACE;


/*** CONSTANTS ***/

#define ECC_MULTI_BIT        0xFF


/*** FUNCTION DECLARATIONS ***/
extern int      is_eos_mem(uint64_t addr);
extern int      is_rpa_mem(uint64_t addr);
extern void     clear_bank_errors(int banknum);
extern void     cache_enable(bool enable);
extern void     print_mce_msg(int bank, uint64_t status, uint64_t addr, uint64_t misc);
extern void     print_mce_end_msg(uint32_t status);
extern int      get_mce_bank_cnt(void);

#endif        /* End of __INCeccP */
