/*******************************************************************************

   logging.h
   Copyright 2016-2019 NetApp, Inc. All Rights Reserved.

   Private error logging structures and functions.

*******************************************************************************/

#ifndef __INClogging
#define __INClogging

#include <linux/types.h>

#include "ecc.h"
#include "eseries_kernel_interface.h"
#include "persistent_region.h"

/* metadata stored in first entry of error region */
typedef struct error_metadata {
    err_entry* error;
    uint32_t next_id;
    uint32_t overflow;
    uint32_t conringc;
    uint32_t conringp;
} err_metadata;

/* implemented in logging.c */
extern int      init_logging_region(struct error_region* region,
                                        bool init_mb_error);
extern uint32_t log_error(uint32_t event_id, uint8_t type, void* data);
extern uint32_t retrieve_errors(err_entry*, bool all);
extern uint32_t acknowledge_error_event(uint32_t event_id);
extern void     dump_error_region(void);

#endif        /* End of __INClogging */
